#include <stdio.h>
#include <time.h>

#include "sync.h"

#ifdef USE_THREAD_ALLOC
#include "threadalloc.h"
#endif

#define N_THREADS    4
#define N_ITERATIONS 100000
#define N_OBJECTS    100

void thread_proc test(void*) { 
    int i, j;
    for (i = 0; i < N_ITERATIONS; i++) { 
	char* obj[N_OBJECTS];
	for (j = 0; j < N_OBJECTS; j++) { 
	    obj[j] = new char[j % 100];
	}
	for (j = 0; j < N_OBJECTS; j++) { 
	    delete[] obj[j];
	}
    }
}

int main(int argc, char* argv[]) 
{
    int i;
    thread_t thread[N_THREADS];
    
#ifdef _WIN32
    if (argc > 1 && strcmp(argv[1], "-1") == 0) { 
	SetProcessAffinityMask(GetCurrentProcess(), 1);
    }
#endif
    time_t start = time(NULL);
    for (i = 0; i < N_THREADS; i++) { 
	thread[i].start(&test, NULL);
    }
    for (i = 0; i < N_THREADS; i++) { 
	thread[i].join();
    }
    printf("Elapsed time: %ld\n", long(time(NULL) - start));
    return 0;
}






